package vzorka_riadkov;

import java.awt.Frame;
import java.awt.Image;
import java.awt.image.FilteredImageSource;
import java.awt.image.RGBImageFilter;


public class GreyScaleFilter extends RGBImageFilter {
	
	private int idx = 0;
	public int[] data;
	
	private Image img;
	
	/**
	 * Konstruktor, nastavi priame filtrovanie obrazku.
	 */
	public GreyScaleFilter() {
		canFilterIndexColorModel = true;
	}
	
	/**
	 * Prevedie zadany obrazok na bielo-cierny.
	 * @param img
	 * @param width
	 * @param height
	 */
	public void calculateGreyScale(Image img, int width) {
		data  = new int[width];
		idx   = 0;				
		
		this.img = new Frame().createImage(
	             new FilteredImageSource(img.getSource(),
		                    this));					
	}
	
	/**
	 * Vrati pole hodnot prevedeneho riadku obrazu.
	 * @return
	 */
	public int[] getData() {
		return data;
	}
	
	/**
	 * Vrati cierno-biely obrazok.
	 * @return
	 */
	public Image getImage() {
		return this.img;
	}
	
	@Override
	public int filterRGB(int x, int y, int color) {

		int red   = (color & 0x00ff0000) >> 16;//zmaze vsetko okrem cervenej a posunie o 16 bitov doprava
		int green = (color & 0x0000ff00) >> 8;
		int blue  = color & 0x000000ff;	

		// aplikujeme ven priemer
		int rgb   = (int) (0.299*red + 0.587*green + 0.114*blue);
		data[idx] = rgb;
		idx++;
		
		// vrtime hodnotu pre kad RGB komponent  
		return (0xff << 24) | (rgb << 16) | (rgb << 8) | rgb;
	}
}

